function [A,D]=two2(x)
    // (2,2) interpolating transform 
    // also known as (5,3) bi-orthogonal integer transform
    // used for lossless image compression in jpeg-2000

    fa=[1 -1/2 -1/2];
    fb=[1 1/4 1/4];
    n=ceil(length(x)/2);
    x=[x 0 0 0];
    for i=1:n
        A(i)=x(2*i)+floor(fa(2)*x(2*i-1)+fa(3)*x(2*i+1));
    end
    A=[0; A];
    for i=1:n
        D(i)=x(2*i-1)+floor(fb(2)*A(i)+fb(3)*A(i+1));
    end
    A=A(2:$);
endfunction
